variables:
  DOCKER_FILE: Dockerfile
  DOCKER_TAG: latest
  DOCKER_IMAGE: ${CI_REGISTRY_IMAGE}
  FF_GITLAB_REGISTRY_HELPER_IMAGE: 1

workflow:
  rules:
    - if: $CI_MERGE_REQUEST_ID               # Execute jobs in merge request context
    - if: $CI_COMMIT_BRANCH == 'main'      # Execute jobs when a new commit is pushed to master branch

stages:
  - prepare
  - build
  - deploy

# Stage: prepare
##############################################################################

.prepare:docker: &prepare_docker
  stage: prepare
  image:
    name: docker
  before_script:
  - docker version
  - docker login --username "${CI_REGISTRY_USER}" --password "${CI_REGISTRY_PASSWORD}" "${CI_REGISTRY}"
  script:
  - docker build --no-cache --pull -f ${DOCKER_FILE} -t ${DOCKER_IMAGE}:${DOCKER_TAG} .
  - docker push ${DOCKER_IMAGE}:${DOCKER_TAG}
  tags:
  - docker-image-builder
  when: manual

prepare:docker:
  <<: *prepare_docker

build:hpc:
  stage: build
  script:
    - export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:.
    - make
    - make test
  image: ${DOCKER_IMAGE}:${DOCKER_TAG}

build:cloud:
  stage: build
  before_script:
    - docker version
    - docker login --username "${CI_REGISTRY_USER}" --password "${CI_REGISTRY_PASSWORD}" "${CI_REGISTRY}"
  script:
    - cd cloud/k8s
    - docker build -f Dockerfile -t registry.git.rwth-aachen.de/acs/public/teaching/sos/cloud:latest .
    - docker push registry.git.rwth-aachen.de/acs/public/teaching/sos/cloud:latest
  image: docker
  tags:
  - docker-image-builder
 
deploy:production:
  stage: deploy
  variables:
    KUBECONFIG: /root/.kube/config
  environment:
    name: production
    url: https://demo.sos.rwth-aachen.de
  image: ${CI_REGISTRY}/acs/internal/cloud/kubernetes/deployment:2
  before_script:
    - mkdir -p $(dirname ${KUBECONFIG})
    - echo "${KUBECONFIG_ENCODED}" | base64 -d > ${KUBECONFIG}
    - kubectl version
  script:
    - kubectl -n teaching-sos apply -f cloud/k8s/httpd.yaml
    - kubectl -n teaching-sos rollout restart deployment sos-httpd
  only:
    refs:
      - main
